package pl.g00n.lmsimport.main;

import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;

import javax.mail.MessagingException;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import pl.g00n.lmsimport.domain.Invoice;
import pl.g00n.lmsimport.service.CsvParser;
import pl.g00n.lmsimport.service.DbManager;
import pl.g00n.lmsimport.service.EmailParser;

public class Main {

	/***
	 * 
	 * @author Lukasz Czerepuk <lukasz@czerepuk.pl> 2012r.
	 * @throws SQLException
	 * @throws ClassNotFoundException
	 * @throws IllegalAccessException
	 * @throws InstantiationException
	 * @throws InterruptedException
	 * 
	 */

	public static void main(String[] args) throws MessagingException,
			IOException, InstantiationException, IllegalAccessException,
			ClassNotFoundException, SQLException, InterruptedException {

		// Log4j
		Logger logger = Logger.getLogger(Main.class);
		PropertyConfigurator.configure("resources/log4j.properties");

		logger.info("Rozpoczynam dzialanie programu....");

		// Laczymy sie do skrzynki pocztowej.
		EmailParser emailParser = new EmailParser("serwer_smtp", "user",
				"haslo");
		CsvParser csvParser = new CsvParser();
		DbManager dbManager = new DbManager();

		// Wykonuujemy dla 4 ostatnich maili
		for (int i = 0; i < 4; i++) {
			String csvString = emailParser.getContentFromMessage(i);

			// Przerabiamy zawartosc tekstowego pliku na kolekcje obiektow
			ArrayList<Invoice> invoices = csvParser.parse(csvString);

			// Jesli kolekcja obiektow nie jest pusta
			if (invoices.size() > 0) {
				// Dopisujemy obiekty do bazy
				dbManager.persistInvoices(invoices);
				// Generujemy formularz do akceptacji wplat
				dbManager.AcceptInvoices();
				// Wysylamy raport mailowy
				emailParser.sendEmailReport(invoices);
			}
		}

		// Akceptujemy zalegle wplaty.
		dbManager.AcceptInvoices();

	}

}
